import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.LinkedList;

public class fran_dfs_robustnetwork {

	static int n, p, t;
	static LinkedList<Integer>[] g;
	static Integer[] time;
	static ArrayList<Integer> leaves;
	
	static StreamTokenizer st = new StreamTokenizer(new InputStreamReader(System.in));
	
	static int nextInt() {
		try {
			st.nextToken();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return (int)st.nval;
	}
	
	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		n = nextInt();
		p = nextInt();
		g = new LinkedList[n];
		for(int i = 0; i < n; i++) {
			g[i] = new LinkedList<>();
		}
		for(int i = 0; i < n - 1; i++) {
			int a = nextInt();
			int b = nextInt();
			g[a].add(b);
			g[b].add(a);
		}
		time = new Integer[n];
		t = 0;
		leaves = new ArrayList<>();
		dfs(p);
		StringBuilder sb = new StringBuilder();
		sb.append(leaves.size() / 2 + leaves.size() % 2 + "\n");
		for(int i = 0; i < leaves.size() / 2 + leaves.size() % 2; i++) {
			int j = (i + leaves.size() / 2) % leaves.size();
			sb.append(String.format("%d %d\n", leaves.get(i), leaves.get(j)));
		}
		System.out.print(sb.toString());
	}
	
	static void dfs(int u) {
		time[u] = t++;
		if(g[u].size() == 1) leaves.add(u);
		for(int v : g[u]) {
			if(time[v] == null) dfs(v);
		}
	}
		
}
