#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    long long n, M; cin >> n >> M; 

    vector<long long> p(n), c(n);

    for(int i = 0; i < n; i++)
        cin >> p[i] >> c[i];

    long long lo = 0, hi = 3000000000LL;
    while(hi - lo > 1) {
        long long mid = (lo + hi)/2LL;
        
        long long res = 0;
        for(int i = 0; i < n; i++) {
            if(mid*p[i] > c[i]) {
                res += mid*p[i] - c[i];
            }
            //if(res >= M)
            //    break;
        }
        if(res >= M)
            hi = mid;
        else
            lo = mid;
    }
    cout << hi << endl;
    return 0;
}
