#include <bits/stdc++.h>
using namespace std;

constexpr int DAYS = 365;
constexpr int mls[12] = {31, 27, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

int calc(const string &ln) {
	int m = int(ln[0]-'0')*10 + int(ln[1]-'0');
	int d = int(ln[3]-'0')*10 + int(ln[4]-'0');
	--m, --d;

	int r = d;
	for (int i = 0; i < m; ++i) r += mls[i];
	return r;
}

int fdist(int d1, int d2) {
	int r = d2 - d1;
	if (r < 0) r += DAYS;
	return r;
}

int main() {
	int n;
	cin >> n;

	vector<int> bds(n);
	for (int &bd : bds) {
		string ln;
		cin >> ln >> ln;
		bd = calc(ln);
	}
	sort(bds.begin(), bds.end());

	int oct27 = calc("10-27");
	int best = 0, bestlen = -1;
	for (int i = 0; i < n; ++i) {
		int nd = (DAYS+bds[(i+1)%n]-1) % DAYS;
		if ((fdist(bds[i], nd) > bestlen)
				|| (fdist(bds[i], nd) == bestlen &&
					fdist(oct27, nd) < fdist(oct27, best))) {
			best = nd;
			bestlen = fdist(bds[i], nd);
		}
	}

	cerr << "Best = " << best << endl;

	int m = 0, d = best, i = 0;
	while (i < 12 && d >= mls[i]) d -= mls[i], ++i, ++m;

	++m, ++d;
	if (m < 10) cout << '0';
	cout << m << '-';
	if (d < 10) cout << '0';
	cout << d << endl;
}
