#include "validation.h"

const long long financialmaxn = 1e5;
const long long financialmaxm = 1e9;
const long long financialmaxp = 1e9;
const long long financialmaxc = 1e9;

// Check the grammar of the input files.
// You should also check properties of the input.
// E.g., check that a graph is connected.
// TODO: Remove these comments, and summarize your input validator.

int main(int argc, char **argv) {
	InputValidator v;
	int n = v.read_long_long(1, financialmaxn);
	v.space();
	v.read_long_long(1, financialmaxm);
	v.newline();

	while (n--) {
		auto p = v.read_long_long(1, financialmaxp);
		v.space();
		auto c = v.read_long_long(1, financialmaxc);
		v.newline();
	}
}
