import java.util.ArrayList;
import java.util.Scanner;
import java.math.BigInteger;
import java.lang.Math;

public class GameNight {
	public static long solve(int n, String s){
		long[] c = new long[3];
		for(int i = 0; i < n; ++i)
			++c[s.charAt(i) - 'A'];
		long total_good = c[0]*c[0] + c[1]*c[1] + c[2]*c[2];
		c[1] += c[0];
		c[2] += c[1];
		long[] v = new long[n];
		for(int i = 0; i<n; ++i){
			++v[(int)(i + n - c[(s.charAt(i) - 'A' + 0) % 3]) % n];
			--v[(int)(i + n - c[(s.charAt(i) - 'A' + 2) % 3]) % n];
		}
		long sum = v[0];
		long m = v[0];
		for(int i = 1; i < n; ++i){
			v[i] += v[i-1];
			sum += v[i];
			m = Math.max(m, v[i]);
		}
		return m + (total_good - sum)/n;
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		String s = sc.next();

		long a = solve(n, s);
		s = new StringBuilder(s).reverse().toString();
		long b = solve(n, s);
		System.out.println(n - Math.max(a,b));

	}

}
